/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package evecentral;

import evecentral.APIS.EvecApi.EvecApi;
import evecentral.APIS.EvecApi.Order;
import evecentral.APIS.IdLookup.Entry;
import evecentral.APIS.IdLookup.EveApi;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.bind.JAXB;


/**
 *
 * @author Cooper
 */
public class ApiHandler{
    private String[] lookupEP = {"https://www.fuzzwork.co.uk/api/typeid.php?typename=","&format=xml"};
    private String stationEP = "https://api.eveonline.com/eve/CharacterID.xml.aspx?names=";
    private String[] quicklookEP = {"http://api.eve-central.com/api/quicklook?typeid=",
        "&sethours=","&setminQ=","&usesystem=","&regionlimit="};
    

    public ApiHandler(){
        //nothing yet
    }
    
    public HashMap<String, List<Order>> getOrders(String itemID){
        return getOrders(itemID, null, false);
    }
    
    public HashMap<String, List<Order>> getOrders(String itemID, List<String> marketLimits, Boolean system){
        HashMap<String, List<Order>> orders = new HashMap<>();
        
        try {
            
            String line = (quicklookEP[0] + itemID);
            
            //tack on market limits to url (regions/system)
            if(marketLimits != null){
                if(system){
                    line += (quicklookEP[3] + marketLimits.get(0));
                }else{
                    for(String region : marketLimits){
                        line += (quicklookEP[4] + region);
                    }
                }
            }
            
            URL url = new URL(line);
            EvecApi api = (EvecApi) JAXB.unmarshal(url, EvecApi.class);
            
            orders.put("sell", api.getQuicklook().getSellOrders().getOrders());
            orders.put("buy", api.getQuicklook().getBuyOrders().getOrders());
            
        } catch (MalformedURLException ex) {
            Logger.getLogger(ApiHandler.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return orders;
    }
    
    public String getID(String item){
        String typeID = "";
        
        try {
            URL url = new URL(lookupEP[0] + item + lookupEP[1]);
            EveApi api = (EveApi) JAXB.unmarshal(url, EveApi.class);
            
            List<Entry> entries = api.getResult().getRowset().getEntries();
            Entry entry = entries.get(0);
            
            typeID = entry.getTypeID();
        } catch (MalformedURLException ex) {
            Logger.getLogger(ApiHandler.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return typeID;
    }
    
    public String getSystemID(String name){
        String id = "";
        
        try {
            URL url = new URL(stationEP + name);
            EveApi api = (EveApi) JAXB.unmarshal(url, EveApi.class);
            
            List<Entry> entries = api.getResult().getRowset().getEntries();
            Entry entry = entries.get(0);
            
            id = entry.getID();
        } catch (MalformedURLException ex) {
            Logger.getLogger(ApiHandler.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return id;
    }
}
