/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package evecentral;

import evecentral.APIS.EvecApi.Order;
import java.awt.Color;
import java.awt.Component;
import java.util.List;
import javax.swing.GroupLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 *
 * @author Cooper
 */
public class FormUtils {
    
    public FormUtils(){
        
    }
    
    public Component[][] addHeaders(Component[][] components){
        String[] headers = {"Security","Station Name","Price","Units Remaining"};
        
        for(int x=0;x<headers.length;x++){
            components[x][0] = new JLabel(headers[x]);
        }
        
        return components;
    } 
    
    public Component[][] createLayoutArray(List<Order> orders){
        int columns = 4;
        int rows = orders.size()+1;
        boolean alt = false;
        Component[][] components = new Component[columns][rows];
        Color beige = new Color(255,255,204);
        
        components = addHeaders(components);
        
        for(int x=0; x<orders.size(); x++){
            Order order = orders.get(x);
            JTextField[] entries = new JTextField[columns];
            
            for(int y=0;y<entries.length;y++){
                switch(y){
                    case 0: entries[y] = new JTextField(order.getSecurity());
                            break;
                    case 1: entries[y] = new JTextField(order.getStationName());
                            break;
                    case 2: entries[y] = new JTextField(order.getPrice());
                            break;
                    case 3: entries[y] = new JTextField(order.getVolume());
                            break;
                }
                
                //alternate colors
                entries[y].setEditable(false);
                if(alt){
                    entries[y].setBackground(beige);
                }else{
                    entries[y].setBackground(Color.WHITE);
                }
                
                components[y][x+1] = entries[y];
            }
            alt = !alt;
            
        }
        
        return components;
    }
    
    public void generateLayout(JPanel jPanel1, Component[][] components){
        //assign rows/columns, using arrays, for applicable restrictions
        int columns = components.length;
        int rows = components[0].length;
        
        //create group layout using current layout
        GroupLayout layout = new GroupLayout(jPanel1);
        
        //auto gaps
        layout.setAutoCreateGaps(true);
        layout.setAutoCreateContainerGaps(true);
        
        //creation of vertical and horizontal group
        GroupLayout.Group hGroup = layout.createSequentialGroup();
        GroupLayout.Group vGroup = layout.createSequentialGroup();
        
        //parallel group arrays for horizontal and vertical group
        GroupLayout.Group[] paraH = new GroupLayout.Group[columns];
        GroupLayout.Group[] paraV = new GroupLayout.Group[rows];
        
        //assign parallel groups to horizontal sequence
        for(int x=0; x < columns; x++){
            
            paraH[x] = layout.createParallelGroup(GroupLayout.Alignment.LEADING);
            for(int y=0;y<rows;y++){
                paraH[x].addComponent(components[x][y]);
            }
            hGroup.addGroup(paraH[x]);
        }
        
        //assign parallel groups to vertical sequence
        for(int x=0; x < rows; x++){
            
            paraV[x] = layout.createParallelGroup(GroupLayout.Alignment.BASELINE);
            for(int y=0;y<columns;y++){
                paraV[x].addComponent(components[y][x]);
            }
            vGroup.addGroup(paraV[x]);
        }
        
        //assign horizontal and vertical group to layout
        layout.setHorizontalGroup(hGroup);
        layout.setVerticalGroup(vGroup);
        
        //assign layout to panel
        jPanel1.setLayout(layout);
    }
}
