/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package evecentral;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author Cooper
 */
public class RegionIDs {
    private HashMap<String, String> regionIDs = new HashMap<>();
    private HashMap<String, String> regionNames = new HashMap<>();
    private String[] list;
    private boolean success = false;
    
    public RegionIDs(){
        //create hashmaps
        try{
            InputStream is = this.getClass().getResourceAsStream("regions.txt");
            BufferedReader br = new BufferedReader(new InputStreamReader(is));
            
            String line;
            String id;
            String region;
            while ((line = br.readLine()) != null) {
                id = line.substring(0,8);
                region = line.substring(9).toLowerCase();
                regionIDs.put(region, id);
                regionNames.put(id, region);
            }
            
            br.close();
            success = true;
        }catch(IOException e){
            System.out.println(e);
        }
        
        //create list
        Collection<String> names = regionNames.values();
        list = names.toArray(new String[names.size()]);
        Arrays.sort(list);
    }
    
    public String getID(String regionName){
        return regionIDs.get(regionName.toLowerCase());
    }
    
    public List<String> getIDs(List<String> regions){
        List<String> IDs = new ArrayList();
        
        for(String region : regions){
            IDs.add(getID(region));
        }
        
        return IDs;
    }
    
    public String getName(String regionID){
        return regionNames.get(regionID);
    }
    
    public String[] getAllRegions(){
        return list;
    }
    
    public boolean isSuccessful(){
        return success;
    }
}
